// ===================
const kCookieScope  = "cookiebar.cookiescope";

var cookieScope     = null;
var cookiemanager   = null;
var cookiesTree     = null;

var observerService;

// ===================
function CookiePanelInit() {
   //cookieScope = nsPreferences.copyUnicharPref(kCookieScope, "all");
   //var theScope = document.getElementById('cookieBarScope');

   //if (cookieScope == "page")
   //   theScope.selectedItem = document.getElementById('scopePage');
   //else
   //   theScope.selectedItem = document.getElementById('scopeAll');

   // xpconnect to cookiemanager interfaces
   cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
   cookiemanager = cookiemanager.QueryInterface(Components.interfaces.nsICookieManager);

   cookiesTree = document.getElementById("cookiesTree");
   loadCookies();

   // be prepared to reload the display if anything changes
   observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
   observerService.addObserver(cookieReloadDisplay, "cookieChanged", false);
}
// ===================
function CookiePanelDestroy() {
   //var theScope = document.getElementById('cookieBarScope');
   //nsPreferences.setUnicharPref(kCookieScope, theScope.value);
   observerService.removeObserver(cookieReloadDisplay, "cookieChanged");
}
// ===================
var cookieReloadDisplay = {
   observe: function(subject, topic, state) {
      if ((topic == "cookieChanged") && (state == "cookies")) {
         // re-draw tree
         loadCookies();
         cookiesTree.treeBoxObject.invalidate();
         dump("cookieReloadDisplay called\n");
      }
   }
}
// ===================
var cookiesTreeView = {
   rowCount : 0,
   setTree : function(tree) {},
   getImageSrc : function(row,column) {},
   getProgressMode : function(row,column) {},
   getCellValue : function(row,column) {},
   getCellText : function(row,column) {
      var rv="";
      if (column=="domainCol") {
        rv = this.cookies[row].host;
      } else if (column=="nameCol") {
        rv = this.cookies[row].name;
      }
      return rv;
   },
   isSeparator : function(index) {return false;},
   isSorted: function() { return false; },
   isContainer : function(index) {return false;},
   cycleHeader : function(aColId, aElt) {},
   getRowProperties : function(row,column,prop){},
   getColumnProperties : function(column,columnElement,prop){},
   getCellProperties : function(row,prop){},
   getLevel: function(index) { return 0; },
   // ========
   cookies : [],
   addCookie : function(host, name, value, expires, path, isSecure, policy) {
      this.cookies[this.cookies.length] = new Cookie(host, name,
                                                     value, expires,
                                                     path, isSecure,
                                                     policy);
      this.rowCount = this.cookies.length;
   },
   // ========
   getCookie:  function(i) { return this.cookies[i]; },
   getHost:    function(i) { return this.cookies[i].host; },
   getName:    function(i) { return this.cookies[i].name; },
   getValue:   function(i) { return this.cookies[i].value; },
   getPath:    function(i) { return this.cookies[i].path; },
   getExpires: function(i) { return this.cookies[i].expires; },
   // ========
   dump: function() {
      for (var i=0; i<this.rowCount; i++)
         dump(this.cookies[i].host+" => "+this.cookies[i].name+"\n");
   },
   // ========
   dropAll: function() {
      this.cookies.length = 0;
      this.rowCount = 0;
   },
   // ========
   dropCookie: function(i) {
      this.cookies.splice(i,1);
      this.rowCount = this.cookies.length;
   },
   // ========
   domainSort: function(asc) {
      if (asc)
         this.cookies.sort(function(a, b) { if ( a.host < b.host ) return -1;
                                            if ( a.host > b.host ) return 1;
                                            return 0; });
      else
         this.cookies.sort(function(a, b) { if ( a.host > b.host ) return -1;
                                            if ( a.host < b.host ) return 1;
                                            return 0; });
   },
   nameSort: function(asc) {
      if (asc)
         this.cookies.sort(function(a, b) { if ( a.name < b.name ) return -1;
                                            if ( a.name > b.name ) return 1;
                                            return 0; });
      else
         this.cookies.sort(function(a, b) { if ( a.name > b.name ) return -1;
                                            if ( a.name < b.name ) return 1;
                                            return 0; });
   }
};
// ===================
function Cookie(host, name, value, expires, path, isSecure, policy) {
   this.host     = host;
   this.sortHost = (host.charAt(0)==".") ? host.substring(1,host.length) : host;
   this.name     = name;
   this.value    = value;
   this.expires  = cookieExpiresString(expires);
   this.path     = path;
   this.isSecure = isSecure;
   this.policy   = policy;
}
// ===================
function loadCookies() {
   cookiesTreeView.dropAll();
   var enumerator = cookiemanager.enumerator;
   var count = 0;
   while (enumerator.hasMoreElements()) {
      var nextCookie = enumerator.getNext();
      nextCookie = nextCookie.QueryInterface(Components.interfaces.nsICookie);
      cookiesTreeView.addCookie(nextCookie.host,
                                nextCookie.name,
                                nextCookie.value,
                                nextCookie.expires,
                                nextCookie.path,
                                nextCookie.isSecure,
                                nextCookie.policy);
   }
   cookiesTreeView.domainSort(true);
   cookiesTree.treeBoxObject.view = cookiesTreeView;
}
// ===================
function cookieSelected() {
   var selections = GetTreeSelections(cookiesTree);
   if (selections.length) {
      document.getElementById("removeCookie").setAttribute("disabled","false");
      document.getElementById("blockCookie").setAttribute("disabled","false");
   } else {
      setProperties("","");
      return true;
   }
   if (1 < selections.length) {
      document.getElementById("prop").setAttribute("disabled","true");
      setProperties("","");
      return true;
   } else
      document.getElementById("prop").setAttribute("disabled","false");

   var idx = selections[0];
   if (idx >= cookiesTreeView.rowCount) {
      dump("Bug 119812 manifesting...selected "+idx+" of "+cookiesTreeView.rowCount+" elements\n");
      return;
   }
   setProperties(cookiesTreeView.getValue(idx), cookiesTreeView.getExpires(idx));
}
// ===================
function setProperties(value, expires) {
   document.getElementById('cookieValue').value = value;
   document.getElementById('cookieExpires').value = expires;
}
// ===================
var lastSortColumn = "";
var lastSortAscending = false;
function cookieColumnSort(column) {
   lastSortAscending = (column == lastSortColumn) ? !lastSortAscending : true;
   lastSortColumn = column;
   if ("domain" == column)
      cookiesTreeView.domainSort(lastSortAscending);
   else if ("name" == column)
      cookiesTreeView.nameSort(lastSortAscending);

   cookiesTree.treeBoxObject.invalidate();
   cookiesTree.treeBoxObject.view.selection.select(-1);
   cookiesTree.treeBoxObject.view.selection.select(0);
}
// ===================
function removeCookie() {
   axeCookie(false);
}
// ===================
function blockCookie() {
   axeCookie(true);
}
// ===================
function axeCookie(block) {
   var s = GetTreeSelections(cookiesTree);
   if (0 == s.length)
      return;

   // this convoluted loop is b/c we need to descend through the cookies...
   //  if we ascend, upper indices will be obi-wan when the array
   //  is collapsed to fill in deleted elements
   for (var i=s.length-1, idx=s[i]; i>=0; idx=s[--i]) {
      cookiemanager.remove(cookiesTreeView.getHost(idx),
                           cookiesTreeView.getName(idx),
                           cookiesTreeView.getPath(idx),
                           block);
      cookiesTreeView.dropCookie(idx);
   }

   // re-draw tree
   cookiesTree.treeBoxObject.invalidate();
   // disable buttons if tree empty, move selection if not
   if (cookiesTreeView.rowCount) {
      var nextSelection = (s[0] < cookiesTreeView.rowCount)
                        ? s[0]
                        : 0;
      cookiesTree.treeBoxObject.view.selection.select(-1);
      cookiesTree.treeBoxObject.view.selection.select(nextSelection);
   } else {
      document.getElementById("removeCookie").setAttribute("disabled","true");
      document.getElementById("blockCookie").setAttribute("disabled","true");
   }

}
// ===================
function cookieProps() {
   var selections = GetTreeSelections(cookiesTree);
   if (1 < selections.length)
      return;
   var idx = selections[0];
   openDialog("chrome://cookiebar/content/cookie-props.xul",
                     "", "centerscreen,chrome,dialog=no,resizable=no,dependent",
                     cookiesTreeView.getCookie(idx));
}
// ===================
function selectAll() {
   cookiesTree.treeBoxObject.view.selection.selectAll();
}
// ===================
